#ifndef _BADPENGUIN_HARDWARE_H
#define _BADPENGUIN_HARDWARE_H


// Bad Penguin - Hardware Detect
// @1999,2000 by Antonio Gallo


// includes
#include <badpenguin-chain.h>

/* typedefs */
typedef struct stComputer    TComputer;
typedef struct stPciDevice   TPciDevice;

/* macro for typecasting */
#define TCOMPUTER(X)    ((TComputer*)(X))
#define TPCIDEVICE(X)   ((TPciDEvice*)(X))

/* structures */
struct stComputer {
  TChain *pci;
};

/* PCI data structure TPciDevice */
struct stPciDevice {
  unsigned int  vendor;
  unsigned int  device;
  unsigned char class;
  unsigned char subclass;
  unsigned int  genericModule;
      // 0 = driver not detected
      // 1 = generic module detected
      // 2 = module detected
      // 3 = module not found
  char *vendorName;
  char *deviceName;
  char *kernelModule;
};

/* functions */
TComputer *create_computer();
int query_pci_devices(TComputer *pc, int loiVerbose);

/* =================== PCI classes and subclasses ================= */
#define PCI_CLASS_STORAGE	0x01
#define PCI_CLASS_STORAGE_SCSI	0x00

#endif
